import { ElementRef, OnDestroy } from '@angular/core';
import { ColumnDefinition, RowData } from '@anjuna/core';
export interface RowContext {
    $implicit: RowData;
    column?: ColumnDefinition;
    index: number;
}
export declare class AnjTable implements OnDestroy {
    private templates;
    element: HTMLAnjTableElement;
    private outletRows;
    private static rowContext;
    private static updateContext;
    constructor(elRef: ElementRef);
    ngOnDestroy(): void;
    cellTemplate(cell: HTMLElement, offset: string, col: ColumnDefinition, row: RowData, rowIndex: number, template: string): void;
    rowTemplate(templateName: string, targetEl: HTMLElement, row: RowData, rowIndex: number): void;
    fromTemplate(templateName: string, targetEl: HTMLElement, row: RowData, rowIndex: number): void;
    private createOutlet;
    private createTemplate;
    private updateOutlet;
    /**
     * Disposes of row templates no longer used in a given row. This ONLY happens if they have specified more than one
     * Template and the end user sorts or filters or otherwise changes the order. If only one template is specified,
     * the output will always match the input -r
     */
    private filterRowTemplates;
}
